// ComFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestOseCommCtl.h"
#include "ComFileDlg.h"


// CComFileDlg dialog

IMPLEMENT_DYNAMIC(CComFileDlg, CDialog)

CComFileDlg::CComFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComFileDlg::IDD, pParent)
	, m_pcFile( _T(""))
	, m_terminalFile(_T(""))
	, m_bContOnNotAvail(false)
	, m_bPcToTerminal( true )
	, m_nDownloadType( 0 )
{

}

CComFileDlg::~CComFileDlg()
{
}

void CComFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDT_PC_FILE, m_edtPcFile);
	DDX_Control(pDX, IDC_EDT_TERMINAL_FILE, m_edtTerminalFile);
}


BEGIN_MESSAGE_MAP(CComFileDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, &CComFileDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CComFileDlg message handlers
BOOL CComFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_pBtnDownType[ 0 ] = (CButton*) GetDlgItem( IDC_RADIO1 );	// Append
	m_pBtnDownType[ 1 ] = (CButton*) GetDlgItem( IDC_RADIO2 );	// Overwrite
	m_pBtnDownType[ 2 ] = (CButton*) GetDlgItem( IDC_RADIO3 );	// New extension
	m_pBtnDownType[ 3 ] = (CButton*) GetDlgItem( IDC_RADIO4 );	// New file
	m_pBtnDownType[ m_nDownloadType ]->SetCheck( TRUE );

	if( m_bPcToTerminal )
	{
		m_pBtnDownType[ 0 ]->EnableWindow( FALSE );
		m_pBtnDownType[ 1 ]->EnableWindow( FALSE );
		m_pBtnDownType[ 2 ]->EnableWindow( FALSE );
		m_pBtnDownType[ 3 ]->EnableWindow( FALSE );
	}
	if( m_bPcToTerminal )
	{
		SetWindowText(L"Send file from PC to Terminal");
	}
	else
	{
		SetWindowText(L"Receive file from Terminal to PC");
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CComFileDlg::OnBnClickedButton1()
{
	CString strFilters = L"All Files (*.*)|*.*|Txt Files (*.TXT)|*.Txt||";

	CFileDialog dlg (m_bPcToTerminal, L"All Files", L"*.*", OFN_NOVALIDATE, strFilters );
	
	if( dlg.DoModal() == IDOK )
	{
		m_edtPcFile.SetWindowTextW( dlg.GetPathName() );
	}
}

void CComFileDlg::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class
	for( int n = 0; n < 4; n++ )
	{
		if( m_pBtnDownType[ n ]->GetCheck() == BST_CHECKED )
		{
			m_nDownloadType = n;
			break;
		}
	}
	m_edtPcFile.GetWindowTextW( m_pcFile );
	m_edtTerminalFile.GetWindowTextW( m_terminalFile );
	m_bContOnNotAvail = (IsDlgButtonChecked( IDC_CHECK1 ) != 0); 

	CDialog::OnOK();
}
