
// TestOseCommCtlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestOseCommCtl.h"
#include "TestOseCommCtlDlg.h"
#include "ComFileDlg.h"
#include "TimeDateDlg.h"
#include "SerialEnum.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestOseCommCtlDlg dialog




CTestOseCommCtlDlg::CTestOseCommCtlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestOseCommCtlDlg::IDD, pParent)
	, m_radioProtocol(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestOseCommCtlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_editTimes);
	DDX_Control(pDX, IDC_STAT_SESSIONID, m_statSessionID);
	DDX_Control(pDX, IDC_STATIC_STAT_INFO, m_statInfo);
	DDX_Control(pDX, IDC_LIST_STAT, m_listStat);
	DDX_Control(pDX, IDC_PROGRESS1, m_progBar);
	DDX_Control(pDX, IDC_OSECOMMCTL1, m_oseCommCtl);
	DDX_Control(pDX, IDC_CMBO_PORT, m_cmboPort);
	DDX_Control(pDX, IDC_CMBO_Baud, m_cmboBaudrate);
	DDX_Control(pDX, IDC_CMBO_IRDA, m_cmboIrda);
}

BEGIN_MESSAGE_MAP(CTestOseCommCtlDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CTestOseCommCtlDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CTestOseCommCtlDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CTestOseCommCtlDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CTestOseCommCtlDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CTestOseCommCtlDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CTestOseCommCtlDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CTestOseCommCtlDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CTestOseCommCtlDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CTestOseCommCtlDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CTestOseCommCtlDlg::OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, &CTestOseCommCtlDlg::OnBnClickedButton11)
	ON_BN_CLICKED(IDC_RADIO1, &CTestOseCommCtlDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CTestOseCommCtlDlg::OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_RADIO3, &CTestOseCommCtlDlg::OnBnClickedRadio3)
	ON_BN_CLICKED(IDC_BUTTON12, &CTestOseCommCtlDlg::OnBnClickedButton12)
END_MESSAGE_MAP()


// CTestOseCommCtlDlg message handlers

BOOL CTestOseCommCtlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_pBtnCommType[ 0 ] = (CButton*) GetDlgItem( IDC_RADIO1 );
	m_pBtnCommType[ 1 ] = (CButton*) GetDlgItem( IDC_RADIO2 );
	m_pBtnCommType[ 2 ] = (CButton*) GetDlgItem( IDC_RADIO3 );

	m_pBtnCommType[ 0 ]->SetCheck( TRUE );

	m_editTimes.SetWindowTextW( L"1" );
	m_editTimes.EnableWindow( FALSE );

	m_cmboBaudrate.SetCurSel( 3 );	// 19200 baud
	m_cmboIrda.SetCurSel( 1 );		// parallax litelink compatible

	m_nPortArray.clear();
	// Fill the comport
	if( CSerialEnum::GetSerialPorts( m_nPortArray ))
	{
		CString strPort;
		list<int>::iterator it;
		for( it = m_nPortArray.begin(); it != m_nPortArray.end(); it++ )
		{
			strPort.Format(_T("COM%d"), *it );
			m_cmboPort.AddString( strPort );
		}
	}	
	m_cmboPort.SetCurSel( 0 );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestOseCommCtlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestOseCommCtlDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestOseCommCtlDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestOseCommCtlDlg::OnBnClickedButton1()
{
	m_oseCommCtl.ClearProtocolOptionsList();
}

void CTestOseCommCtlDlg::OnBnClickedButton2()
{
	CTimeDateDlg dlg;

	if( dlg.DoModal() == IDOK )
	{
		m_oseCommCtl.AddGetTerminalTimeDate( dlg.GetTimeDateFormat());
//		m_oseCommCtl.AddGetTerminalTimeDate( m_oseCommCtl.tdFmthhmmssDDMMYYYYY);
	}
}

void CTestOseCommCtlDlg::OnBnClickedButton3()
{
	m_oseCommCtl.AddSetTerminalTimeDate( 12, 5, 30, 14, 5, 1975 );
}

void CTestOseCommCtlDlg::OnBnClickedButton4()
{
	m_oseCommCtl.AddSetTerminalLocalTimeDate();
}

void CTestOseCommCtlDlg::OnBnClickedButton5()
{
	CString strTimes;
	int times = 0;
	long commType;

	if( m_pBtnCommType[ 0 ]->GetCheck() == BST_CHECKED )
	{
		commType = m_oseCommCtl.commContinuous;
	}
	else if( m_pBtnCommType[ 1 ]->GetCheck() == BST_CHECKED )
	{
		commType = m_oseCommCtl.commSuccess; 
		m_editTimes.GetWindowTextW( strTimes );
		times = _wtoi( strTimes );
	}
	else
	{
		commType = m_oseCommCtl.commNoAnswer;
		m_editTimes.GetWindowTextW( strTimes );
		times = _wtoi( strTimes );
	}
		// Store the new serial port
	list<int>::iterator it;
	it = m_nPortArray.begin();
	advance( it, m_cmboPort.GetCurSel() );

	DWORD baud[] = { 115200UL, 57600UL, 38400UL, 19200UL, 9600UL, 4800UL };
	m_oseCommCtl.put_Comport( (short)*it );
	m_oseCommCtl.put_Baudrate( baud[ m_cmboBaudrate.GetCurSel()] );
	m_oseCommCtl.put_IrDADevice( m_cmboIrda.GetCurSel());
	m_oseCommCtl.StartProtocol( commType, times ); 
}

void CTestOseCommCtlDlg::OnBnClickedButton6()
{
	CComFileDlg dlg;
	
	dlg.SetSendFileToTerminal( false );
	if( dlg.DoModal() == IDOK )
	{
		// Receive file
		m_oseCommCtl.AddReceiveFileFromTerminal( dlg.GetPCFile(), dlg.GetDownloadType(), dlg.GetTerminalFile(), 0, dlg.GetContinueOnNotAvail());
	}
}

void CTestOseCommCtlDlg::OnBnClickedButton7()
{
	// Transmit file
	CComFileDlg dlg;
	
	dlg.SetSendFileToTerminal( true );
	if( dlg.DoModal() == IDOK )
	{
		// Receive file
		m_oseCommCtl.AddTransmitFileToTerminal( dlg.GetPCFile(),dlg.GetTerminalFile(), 0, dlg.GetContinueOnNotAvail());
	}
}

void CTestOseCommCtlDlg::OnBnClickedButton8()
{
	// Get OS Version
	m_oseCommCtl.AddGetTerminalOSVersion();
}

void CTestOseCommCtlDlg::OnBnClickedButton9()
{
	// Get Application version
	m_oseCommCtl.AddGetTerminalApplicationVersion();
}

void CTestOseCommCtlDlg::OnBnClickedButton10()
{
	// Get file listing
	m_oseCommCtl.AddGetTerminalFileList(L"*.*", 0 );
}

void CTestOseCommCtlDlg::OnBnClickedButton11()
{
	// TODO: Add your control notification handler code here
	m_oseCommCtl.StopProtocol();
}

void CTestOseCommCtlDlg::OnBnClickedRadio1()
{
	// TODO: Add your control notification handler code here
	m_editTimes.EnableWindow( FALSE );
}

void CTestOseCommCtlDlg::OnBnClickedRadio2()
{
	// TODO: Add your control notification handler code here
	m_editTimes.EnableWindow();
}

void CTestOseCommCtlDlg::OnBnClickedRadio3()
{
	// TODO: Add your control notification handler code here
	m_editTimes.EnableWindow();
}
BEGIN_EVENTSINK_MAP(CTestOseCommCtlDlg, CDialog)
	ON_EVENT(CTestOseCommCtlDlg, IDC_OSECOMMCTL1, 1, CTestOseCommCtlDlg::ConnectedOsecommctl1, VTS_I4)
	ON_EVENT(CTestOseCommCtlDlg, IDC_OSECOMMCTL1, 2, CTestOseCommCtlDlg::ProgressOsecommctl1, VTS_I2)
	ON_EVENT(CTestOseCommCtlDlg, IDC_OSECOMMCTL1, 3, CTestOseCommCtlDlg::StatusInformationOsecommctl1, VTS_I2 VTS_BSTR)
END_EVENTSINK_MAP()

void CTestOseCommCtlDlg::ConnectedOsecommctl1(long terminalID)
{
	// TODO: Add your message handler code here
	CString str;
	str.Format(L"%06.6lX", terminalID );
	m_statSessionID.SetWindowTextW( str );

	int count = m_listStat.AddString( str );
	m_listStat.SetCaretIndex(count );
}

void CTestOseCommCtlDlg::ProgressOsecommctl1(short percentage)
{
	// TODO: Add your message handler code here
	m_progBar.SetPos( percentage );
}

void CTestOseCommCtlDlg::StatusInformationOsecommctl1(short status, LPCTSTR message)
{
	m_statInfo.SetWindowTextW( message );
	//m_listStat.InsertString( 0, message );
	int count = m_listStat.AddString( message );
	m_listStat.SetCaretIndex(count );
}

void CTestOseCommCtlDlg::OnBnClickedButton12()
{
	m_listStat.ResetContent();
}
